package be.ugent.jvl.user;

import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.paint.Color;

public class UserController {

    public TextField voornaam;

    public Label voornaamError;

    public Label voornaamLabel;

    public TextField naam;

    public Label naamError;

    public Label naamLabel;

    public Label resultaat;

    private String nummerUitNaam(String voornaam, String naam) {
        String resultaat = voornaam.trim().substring(0, 1) + naam;
        resultaat = resultaat.replaceAll("\\s", "").toLowerCase();
        if (resultaat.length() > 8) {
            return resultaat.substring(0, 8);
        } else {
            return resultaat;
        }

    }

    public void maakNummer() {
        checkVoornaam();
        checkNaam();
        if (voornaamError.isVisible() || naamError.isVisible()) {
            resultaat.setText("");
        } else {
            resultaat.setText(
                    nummerUitNaam(voornaam.getText(), naam.getText())
            );
        }

    }
    
    private void checkLabel (TextField field, Label errorLabel, Label titelLabel) {
        boolean leeg = field.getText().trim().isEmpty();
        errorLabel.setVisible(leeg);
        if (leeg) {
            titelLabel.setTextFill(Color.RED);
        } else {
            titelLabel.setTextFill(Color.BLACK);
        }
        // bovenstaande kan ook afgekort worden tot:
        // titelLabel.setTextFill(leeg ? Color.RED : Color.BLACK);
    }
    
    public void checkVoornaam () {
        checkLabel (voornaam, voornaamError, voornaamLabel);
    }
    
    public void checkNaam () {
        checkLabel (naam, naamError, naamLabel);
    }
}
